'use strict'
const YAML = require('yamljs')
const fs = require('fs')
const stream = require('stream')
const through = require('through2')

/*
 * Original package from which this has been derived:
 * https://github.com/jenslind/drupal-breakpoints-scss
 */

const calls = {}

function jsonToScssVars (obj) {

  let breakpoints = '$breakpoints: (\n'

  for (let i in obj) {
    let bp_value = obj[i].mediaQuery.replace(/[^\d]/, '')
    breakpoints += obj[i].label + ': ' + bp_value + ',\n'
  }

  breakpoints += ');\n'
  return breakpoints

}

calls.read = function (path) {
  let rs = stream.Readable()
  let breakpoints = YAML.load(path)

  rs._read = function () {
    rs.push(jsonToScssVars(breakpoints))
    rs.push(null)
  }

  return rs
}

calls.write = function (path) {
  let scssFile = fs.createWriteStream(path)
  return scssFile
}

calls.ymlToScss = function () {
  return through.obj(function (file, enc, cb) {
    var content = file.contents.toString('utf8')
    var parsedYaml = YAML.parse(content)
    file.contents = new Buffer(String(jsonToScssVars(parsedYaml)))
    cb(null, file)
  })
}

module.exports = calls
